//*****************************************************************************
//* FILE NAME:       IMBDrvWMI.h
//* FILE CONTAINS:
//* DESCRIPTION:     WMI support for Win 2000.
//*****************************************************************************
//*                   INTEL CORPORATION PROPRIETARY INFORMATION
//*     This software is supplied under the terms of a license agreement or
//*     nondisclosure agreement with Intel Corporation and may not be copied
//*     or disclosed except in accordance with the terms of that agreement.
//*           Copyright (c) 1995 Intel Corporation.  All Rights Reserved.
//*****************************************************************************

#ifndef D_IMBDrvWMI_HeaderFile
#define D_IMBDrvWMI_HeaderFile

#include "CompDiag.h"

#ifdef D_CompilerDiagnostics
   #pragma D_CompDiagMsg("Include")
#endif

//*****************************************************************************
//* INCLUDES
//*****************************************************************************

//-----------------------------------------------------------------------------
// Include generated by MOF compiler.
//-----------------------------------------------------------------------------

#include "w2k_wmi.h"
#include "IMBDrvMOF.h"

//*****************************************************************************
//* PROTOTYPES
//*****************************************************************************

extern NTSTATUS gtDeviceIoControl(struct S_WMI_MethodArg *asp_WMI_MethodArg);

//*****************************************************************************
//* VARIABLEs
//*****************************************************************************

//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------

#ifdef D_InitWMI_Info

   #ifdef D_CompilerDiagnostics

      #pragma D_CompDiagMsg("Define WMI GUID registry information")

   #endif

   //--------------------------------------------------------------------------
   // Base name for WMI object instances; otherwise, arbitrary path to PDO
   // would be used.
   //--------------------------------------------------------------------------

   //--------------------------------------------------------------------------
   // {<GUID>,<# instances in each device>,<Flag as expensive to collect>}
   //--------------------------------------------------------------------------

   WMIGUIDREGINFO gta_WMIGUIDREGINFO[]
      = {
         {&ID_MOF_C_mvDeviceIoControl_Args_GUID,   1, 0},
         {&ID_MOF_C_DeviceIoControl_GUID,          1, 0},
         };

   //--------------------------------------------------------------------------
   //
   //--------------------------------------------------------------------------

   struct S_WMI_Method gsaID_MOF_C_DeviceIoControl[]
      = {
         {gtDeviceIoControl, ID_MOF_mvDeviceIoControl,   sizeof(struct _ID_MOF_C_mvDeviceIoControl_Args)}
         };

   //--------------------------------------------------------------------------
   //
   //--------------------------------------------------------------------------

   struct S_QueryWMI_DataBlock gsa_QueryWMI_DataBlock[]
      = {
         {NULL,                                 0},   // ID_MOF_C_mvDeviceIoControl_Args
         {gsaID_MOF_C_DeviceIoControl,          D_NumWMI_Methods(gsaID_MOF_C_DeviceIoControl)}
         };

#endif

#endif