;/*++ BUILD Version: 0001    // Increment this if a change has global effects
;
;Copyright (c) 1992, 1993  Microsoft Corporation
;
;Module Name:
;
;    msmclog.mc
;
;Abstract:
;
;    Constant definitions for the I/O error code log values.
;
;
;Revision History:
;
;--*/
;
;
;//
;//  Status values are 32 bit values layed out as follows:
;//
;//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
;//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
;//  +---+-+-------------------------+-------------------------------+
;//  |Sev|C|       Facility          |               Code            |
;//  +---+-+-------------------------+-------------------------------+
;//
;//  where
;//
;//      Sev - is the severity code
;//
;//          00 - Success
;//          01 - Informational
;//          10 - Warning
;//          11 - Error
;//
;//      C - is the Customer code flag
;//
;//      Facility - is the facility code
;//
;//      Code - is the facility's status code
;//
;
MessageIdTypedef = NTSTATUS

SeverityNames = (       Success=0x0:STATUS_SEVERITY_SUCCESS
					Informational=0x1:STATUS_SEVERITY_INFORMATIONAL
					Warning=0x2:STATUS_SEVERITY_WARNING
					Error=0x3:STATUS_SEVERITY_ERROR
				)

FacilityNames = (       System=0x0
					RpcRuntime=0x2:FACILITY_RPC_RUNTIME
					RpcStubs=0x3:FACILITY_RPC_STUBS
					Io=0x4:FACILITY_IO_ERROR_CODE
					Imb=0x7:IMB_IO_ERROR_CODE
				)



MessageId=0x0001 Facility=Imb Severity=Error SymbolicName=INSUFFICIENT_RESOURCES
Language=English
Not enough memory for internal storage  of device %1.
.

MessageId=0x0002 Facility=Imb Severity=Error SymbolicName=INVALID_INPUT_BUFFER
Language=English
Invalid Input Arguments passed to  IMB driver
.

MessageId=0x0003 Facility=Imb Severity=Error SymbolicName=INVALID_OUTPUT_BUFFER
Language=English
Improper Buffer size for output values from IMB driver
.

MessageId=0x0004 Facility=Imb Severity=Error SymbolicName=IMB_SEND_TIMEOUT
Language=English
Timeout during sending an IMB request
.

MessageId=0x0005 Facility=Imb Severity=Error SymbolicName=IMB_RECEIVE_TIMEOUT
Language=English
Timeout during receiving an IMBP response
.

MessageId=0x0006 Facility=Imb Severity=Error SymbolicName=IMB_IF_SEND_TIMEOUT
Language=English
Timeout during sending a BMC request
.

MessageId=0x0007 Facility=Io Severity=Error SymbolicName=IMB_IF_RECEIVE_TIMEOUT
Language=English
Timeout during receiving a BMC response
.

MessageId=0x0008 Facility=Io Severity=Error SymbolicName=HARDWARE_FAILURE
Language=English
Imb hardware failed or it does not exsist
.

MessageId=0x0009 Facility=Io Severity=Error SymbolicName=DRIVER_FAILURE
Language=English
Imb driver does not respond or it is not loaded
.
 
MessageId=0x000A Facility=Io Severity=Error SymbolicName=IMB_INVALID_IF_RESPONSE
Language=English
Error during communication with BMC through SMS stream
.

MessageId=0x000B Facility=Io Severity=Error SymbolicName=IMB_INVALID_PACKET
Language=English
Received IMB packet had a bad format or checksum
.

MessageId=0x000C Facility=Io Severity=Error SymbolicName=IMB_RESPONSE_DATA_OVERFLOW
Language=English
Response data size is more than application allocated buffer size
.

MessageId=0x000D Facility=Imb Severity=Error SymbolicName=IMB_INVALID_REQUEST
Language=English
Invalid data found in IMB request frame
.

MessageId=0x000E Facility=Imb Severity=Error SymbolicName=INVALID_DRIVER_IOCTL
Language=English
Request code not handled by the Imb driver
.

MessageId=0x000F Facility=Imb Severity=Error SymbolicName=INVALID_DRIVER_REQUEST
Language=English
Invalid IOCTL passed to the Imb driver
.

MessageId=0x0010 Facility=Imb Severity=Error SymbolicName=IMB_CANT_GET_SMS_BUFFER
Language=English
Error while trying to read SMS buffer
.

MessageId=0x0011 Facility=Imb Severity=Error SymbolicName=INPUT_BUFFER_TOO_SMALL
Language=English
Input buffer is too small to hold the available data
.

MessageId=0x0012 Facility=Imb Severity=Error SymbolicName=IMB_MSG_NOT_AVAILABLE
Language=English
No asynchronous messages available
.
MessageId=0x0013 Facility=Imb Severity=Error SymbolicName=IMB_SEND_ERROR
Language=English
Error occured when sending request
.



